#ifndef PLAYER_GUI_H
#define PLAYER_GUI_H

#include <QMainWindow>
#include <QObject>
#include <QFile>
#include <QFrame>
#include <QListWidget>
#include <vlc/vlc.h>

namespace Ui {
class player_gui;
}

class player_gui : public QMainWindow{
    Q_OBJECT

    public:
        explicit player_gui(QWidget *parent = 0);
        ~player_gui();

    private slots:
        void on_actionBeenden_triggered();
        void on_actionIP_Adresse_triggered();
        void on_lineEdit_textChanged(const QString &arg1);
        int play(QListWidgetItem *item);

        void on_listWidget_itemClicked(QListWidgetItem *item);

private:
        Ui::player_gui *ui;
        void set_ip(void);
        static size_t write_data(void*, size_t, size_t , void*);
        int sender_holen(void);
        int sender_laden(void);
        int sender_ausgeben(void);
        int Sender;
        QString Name[10000];
        QString URL[10000];
        QString ip;
        QFrame *videoWidget;
        libvlc_instance_t * inst;
        libvlc_media_player_t *mp=0;
        libvlc_media_t *m;
};

#endif // PLAYER_GUI_H
